--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------

-- Define a function to handle changes made in the parameter editor
--variables
  local function isLineEmpty(lineID, columnID)
    local patTrack = renoise.song().selected_pattern_track
     local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
    -- Check if the line is not empty
    local isLineNotEmpty = true
        if deviceString ~= "00" then
            isLineNotEmpty = false
        end
    
       return isLineNotEmpty

    end

local function ParameterLockShort()
  print("___")
  local trackID = renoise.song().selected_track_index
  local patternID = renoise.song().selected_pattern_index
  local patTrack = renoise.song().selected_pattern_track
  local deviceID = renoise.song().selected_device_index
  local parameterID = renoise.song().selected_automation_parameter
  local columnID = renoise.song().selected_effect_column_index
  local lineID = renoise.song().selected_line_index
  local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
  local deviceStringSplit = tonumber(deviceString:sub(2))
  local parameterValue = (renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value)
  local parameterString = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_string
  local valueMin = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_min
  local valueMax = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_max
  local editStep = renoise.song().transport.edit_step
  if editStep == 0 then
  editStep = 1
  end
  print(editStep)
  local lineDown = lineID + editStep
  local lineUp = lineID - 1
  local track = renoise.song().selected_track
  local valueMinAbs = math.abs(valueMin)
  local math = (valueMinAbs+valueMax)
  local parameterOld = (valueMinAbs +parameterValue)*255/math
  local pattern = renoise.song().selected_pattern
  local effect = patTrack:line(lineDown).effect_columns[columnID]
  local pattern = renoise.song().selected_pattern
  local patternLength = pattern.number_of_lines
  local parameter = renoise.song().selected_parameter  
  
  if lineUp >= 1 then
    if isLineEmpty(lineUp,columnID ) then
    patTrack:line(lineUp).effect_columns[columnID].amount_value = parameterOld
    patTrack:line(lineUp).effect_columns[columnID].number_string = deviceString
    else end
  else end
  
  if lineDown <= patternLength then
    if isLineEmpty(lineDown, columnID) then
    patTrack:line(lineDown).effect_columns[columnID].amount_value = parameterOld
    patTrack:line(lineDown).effect_columns[columnID].number_string = deviceString
    else end
  else end
  

   
end
   
  
  
  local function ParameterLockLong()
  print("___")
  local trackID = renoise.song().selected_track_index
  local patternID = renoise.song().selected_pattern_index
  local patTrack = renoise.song().selected_pattern_track
  local deviceID = renoise.song().selected_device_index
  local parameterID = renoise.song().selected_automation_parameter
  local columnID = renoise.song().selected_effect_column_index
  local lineID = renoise.song().selected_line_index
  local deviceString = patTrack:line(lineID).effect_columns[columnID].number_string
  local deviceStringSplit = tonumber(deviceString:sub(2))
  local parameterValue = (renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value)
  local parameterString = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_string
  local valueMin = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_min
  local valueMax = renoise.song().tracks[trackID].devices[deviceID].parameters[deviceStringSplit].value_max
  local lineUp = lineID - 1
  local track = renoise.song().selected_track
  local valueMinAbs = math.abs(valueMin)
  local math = (valueMinAbs+valueMax)
  local parameterOld = (valueMinAbs +parameterValue)*255/math
  local pattern = renoise.song().selected_pattern
  local pattern = renoise.song().selected_pattern
  local patternLength = pattern.number_of_lines
  local parameter = renoise.song().selected_parameter  
  local lineDown = lineID+1
  local effect = patTrack:line(lineDown).effect_columns[columnID]
  if lineUp >= 1 then
    if isLineEmpty(lineUp,columnID ) then
    patTrack:line(lineUp).effect_columns[columnID].amount_value = parameterOld
    patTrack:line(lineUp).effect_columns[columnID].number_string = deviceString
    else end
  else end
  
  

  while(renoise.song().patterns[patternID].tracks[trackID].lines[lineDown].note_columns[1].note_value==121) do
    lineDown = lineDown + 1
   -- print(tostring(renoise.song().patterns[patternID].tracks[trackID].lines[lineDown].note_columns[1].note_value))
    --print(lineDown)
  end
  
  if lineDown <= patternLength then
    if isLineEmpty(lineDown, columnID) then
    patTrack:line(lineDown).effect_columns[columnID].amount_value = parameterOld
    patTrack:line(lineDown).effect_columns[columnID].number_string = deviceString
    else end
  else end
  

   
end
  
  
  
  
  

--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------
--[[
renoise.tool():add_menu_entry {
  name = "Main Menu:Edit:"..tool_name,
  invoke = ParameterLock
}
--]]

--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------


renoise.tool():add_keybinding {
  name = "Global:Tools:" .. tool_name.."Short",
  invoke = ParameterLockShort
}

renoise.tool():add_keybinding {
  name = "Global:Tools:" .. tool_name.."Long",
  invoke = ParameterLockLong
}

